//-----------------------------------------------------
// Organic by Andreas Gustafsson (Shadow/Noice) (C)1999
//-----------------------------------------------------
#include "stdafx.h"
#include "Texture.h"

#define CIRC_DIVS 32
#define NR_SEGS 32

//----------------------------------------
// Usefull debugger thingy.
void DebugOut(const char *szFormat, ...);
//----------------------------------------

// Change your App Name.
char szAppName[] = "Organic by Andreas Gustafsson (Shadow/Noice) (C)1999";

// Timer info.  Very useful for keeping animated stuff in sync on different computers.
extern float fTime, fDeltaTime;

// Current window dimensions.
extern GLsizei g_w, g_h;

// Use the demonstration texture.
CTexture gTexExample;
CTexture gTexExample2;

GLUquadricObj *quadObj;

double v1=0,v2=0,v3=0,v4=0,rv1=0,rv2=0,rv3=0;

float random(float high)
{
    return((float)((double)rand()/32768)*high);
}

// Startup Stuff.
bool Init()	// Called right after the window is created, and OpenGL is initialized.
{
	glViewport (0, 0, (GLsizei) g_w, (GLsizei) g_h); 
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective(55.0, (GLfloat) g_w/(GLfloat) g_h, 1.0, 20.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef (0.0, 0.0, -3.0);
	glClearColor(0.0,0.0,0.0,0.0);

	gTexExample.LoadJPG("chunky.jpg" );
	gTexExample2.LoadJPG("mud5.jpg" );
	glEnable( GL_TEXTURE_2D );

	glEnable(GL_DEPTH_TEST);

	quadObj=gluNewQuadric();
	gluQuadricTexture(quadObj,true); 

	return true;
}

void Shutdown() // Called right after the window is destroyed.
{
}

void drawStrip(double z1,double z2,double r1,double r2,double t1,double t2,double x1,double x2,double y1,double y2)
{
	int i;

	gTexExample.Use(); 
	glBegin(GL_TRIANGLE_STRIP);
	for(i=0;i<=CIRC_DIVS;i++)
	{
		glTexCoord2f((float)i*2/CIRC_DIVS,(float)t1);
		glColor3f((float)(0.5f+r1),(float)(0.5f+r1),(float)(0.5f+r1));
		glVertex3f((float)(x1+r1*cos(i*PI/(CIRC_DIVS/2.0f))),(float)(y1+r1*sin(i*PI/(CIRC_DIVS/2.0f))),(float)z1);
		glTexCoord2f((float)i*2/CIRC_DIVS,(float)t2);
		glColor3f((float)(0.5f+r2),(float)(0.5f+r2),(float)(0.5f+r2));
		glVertex3f((float)(x2+r2*cos(i*PI/(CIRC_DIVS/2.0f))),(float)(y2+r2*sin(i*PI/(CIRC_DIVS/2.0f))),(float)z2);
	}
	glEnd();
}

void drawSphere()
{
	gTexExample2.Use(); 
	glColor3f(0.7f,0.4f,0.5f);
	gluSphere(quadObj,3.5f,16,16);
}

// Draw all the scene related stuff.
void Render()
{
	int i;
	double z1,z2,r1,r2,t1,t2,x1,x2,y1,y2;

	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glPushMatrix();
	glRotatef((float)rv1, 1.f, 0, 0 );
	glRotatef((float)rv2, 0, 1.f, 0 );
	glRotatef((float)rv3, 0, 0, 1.f );
	drawSphere();
	for(i=0;i<NR_SEGS;i++)
	{
		z1=-2+4*(float)i/NR_SEGS;
		z2=-2+4*((float)i+1)/NR_SEGS;
		r1=0.6+0.1*sin((i+v1*PI)/2.0)+0.2*sin((i+v2*PI)/4.0);
		r2=0.6+0.1*sin(((i+1)+v1*PI)/2.0)+0.2*sin(((i+1)+v2*PI)/4.0);
		r1=r1*sin((float)i*PI/NR_SEGS);
		r2=r2*sin((float)(i+1)*PI/NR_SEGS);
		t1=2*(float)i/NR_SEGS;
		t2=2*((float)i+1)/NR_SEGS;
		x1=0.2*sin((i+v3*PI)/4.0);
		x2=0.2*sin((i+1+v3*PI)/4.0);
		y1=0.1*sin((i+v4*PI)/2.0);
		y2=0.1*sin((i+1+v4*PI)/2.0);
		drawStrip(z1,z2,r1,r2,t1,t2,x1,x2,y1,y2);
	}
	v1+=fDeltaTime*4;
	if(v1>1024) v1-=1024;
	v2+=fDeltaTime*3;
	if(v2>1024) v2-=1024;
	v3+=fDeltaTime*5;
	if(v3>1024) v3-=1024;
	v4+=fDeltaTime*2.8;
	if(v4>1024) v4-=1024;
	rv1+=10.0f*fDeltaTime;
	if(rv1>360) rv1-=360;
	rv2+=10.0f*fDeltaTime;
	if(rv2>360) rv2-=360;
	rv3+=10.0f*fDeltaTime;
	if(rv3>360) rv3-=360;

	glPopMatrix();
}
